<?php

namespace App\Http\Controllers;

use App\Models\TypeTache;
use Dotenv\Validator;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Validator as FacadesValidator;
use RealRashid\SweetAlert\Facades\Alert;

class TypeTacheController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
     return view('Admin.pages.File_TypeTache.TypeTache');
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
     $donnees = TypeTache::all(); // Remplacez "VotreModele" par le nom de votre modèle de données

    return response()->json($donnees);
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        $rules = array(
            'nomTypeTache' => 'required',
        );

        $error = FacadesValidator::make($request->all(), $rules);

        if ($error->fails()) {
            Alert::toast('Add success','success');

            return redirect()->back()->withErrors($error)->withInput();
        }

        try {
            $form_data = array(
                'nomTypeTache' => $request->nomTypeTache,
            );
            TypeTache::create($form_data);
            Alert::toast('Add success','success');
            return redirect()->back()->withInput();
        } catch (\Illuminate\Database\QueryException $exception) {
        Alert::toast('Une erreur s\'est produite lors de l\'ajout','error' /*. $exception->getMessage()*/);
            return redirect()->back()->withInput();
        }
    }

    /**
     * Display the specified resource.
     *
     * @param  \App\Models\GestionBatiments  $gestionBatiments
     * @return \Illuminate\Http\Response
     */
    public function show(Request $request)
    {


    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  \App\Models\GestionBatiments  $gestionBatiments
     * @return \Illuminate\Http\Response
     */
      public function edit($id)
    {
        $TypeTaches = TypeTache::find($id);
        return response()->json([
            'status' => 200,
            'TypeTaches' => $TypeTaches,
        ]);
    }


    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \App\Models\GestionBatiments  $gestionBatiments
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request)
    {
        //la route update a été détacher de la route ressource  (faite un php artisan route:list)
        $TypeTache_id = $request->input('id');
        $TypeTache = TypeTache::find($TypeTache_id);
        try {
            $TypeTache->nomTypeTache = $request->input('nomTypeTache');
            $TypeTache->update();
            Alert::toast('Update success','success');
            return redirect()->route('TypeTache.index');
        } catch (\Illuminate\Database\QueryException $exception) {
            Alert::toast('Veuillez rempli tous champs','error');
            return redirect()->back()->withInput();
        }
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  \App\Models\GestionBatiments  $gestionBatiments
     * @return \Illuminate\Http\Response
     */
    public function destroy(Request $request)
    {

        $data_id = $request->input('deleteTypeTache');
        $data = TypeTache::find($data_id);

        try {
            $data->delete();
            Alert::toast('Delete success','success');
        } catch (\Illuminate\Database\QueryException $exception) {
            $errorInfo = $exception->errorInfo;

            if ($errorInfo[0] === '23000' && $errorInfo[1] === 1451) {
                $affectedTables = $this->getAffectedTables($errorInfo[2]);
                $errorMessage = "Impossible de supprimer l'événement. Il est référencé dans les tableaux suivants : " . implode(", ", $affectedTables);
                Alert::toast($errorMessage,'error');
            } else {
                Alert::toast($exception->getMessage(),'error');
            }
        }

        return  redirect()->back()->withInput();
    }

    private function getAffectedTables($errorMessage)
    {
        preg_match_all("/`(.+?)`/", $errorMessage, $matches);
        return $matches[1];
    }
}
